stages:
  - build
  - deploy

variables:
  MICROSERVICE_NAME: notification-microservice

build:
  stage: build
  tags:
    - build
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - echo "$APP_SETTINGS_DEV" > "$(pwd)/appsettings.Dev.json"
    - docker pull $CI_REGISTRY_IMAGE:latest || true
    - docker build --cache-from $CI_REGISTRY_IMAGE:latest --tag $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA --tag $CI_REGISTRY_IMAGE:latest .
    - docker push $CI_REGISTRY_IMAGE:latest
  allow_failure: true
  only:
    refs:
      - master

deploy:
  stage: deploy
  tags:
    - deploy
  script:
    - curl -LO https://storage.googleapis.com/kubernetes-release/release/v1.20.5/bin/linux/amd64/kubectl
    - chmod +x ./kubectl
    - mv ./kubectl /usr/local/bin/kubectl
    - mkdir ~/.kube || true
    - cp $K8S_CONFIG ~/.kube/config
    - kubectl rollout restart deploy $MICROSERVICE_NAME
  only:
    refs:
      - master
